<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "salesforce_entity".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "SalesforceEntity".
 *
 * Columns in table "salesforce_entity" available as properties of the model,
 * followed by relations of table "salesforce_entity" available as properties of the model.
 *
 * @property integer $id
 * @property integer $salesforce_object_type_id
 * @property string $status
 * @property string $last_update
 * @property string $date_added
 * @property string $date_updated
 * @property string $rich_data
 * @property string $salesforce_id
 *
 * @property SalesforceObjectType $salesforceObjectType
 * @property SalesforceEntityMapping[] $salesforceEntityMappings
 */
abstract class BaseSalesforceEntity extends BaseModel
{
    public $entity_table = '';
    public $entity_id = '';
    public $salesforce_entity_id = '';
    public $salesforce_object = '';
    public $salesforce_entity_mapping_id = '';

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'salesforce_entity';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'SalesforceEntity|SalesforceEntities', $n);
    }

    public static function representingColumn()
    {
        return 'date_added';
    }

    public function rules()
    {
        return array(
            array('salesforce_id', 'required'),
            array('salesforce_object_type_id', 'numerical', 'integerOnly'=>true),
            array('status', 'length', 'max'=>100),
            array('salesforce_id', 'length', 'max'=>18),
            array('last_update, rich_data', 'safe'),
            array('status, last_update, rich_data, salesforce_id', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, salesforce_object_type_id, status, last_update, date_added, date_updated, rich_data, salesforce_id, salesforce_entity_mapping_id, entity_table, entity_id, salesforce_entity_id, salesforce_object', 'safe', 'on'=>'search'));
    }

    public function relations()
    {
        return array(
            'salesforceObjectType' => array(self::BELONGS_TO, 'SalesforceObjectType', 'salesforce_object_type_id'),
            'salesforceEntityMappings' => array(self::HAS_MANY, 'SalesforceEntityMapping', 'salesforce_entity_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'salesforce_object_type_id' => null,
            'status' => Yii::t('app', 'Status'),
            'last_update' => Yii::t('app', 'Last Update'),
            'date_added' => Yii::t('app', 'Date Added'),
            'date_updated' => Yii::t('app', 'Date Updated'),
            'rich_data' => Yii::t('app', 'Rich Data'),
            'salesforce_id' => Yii::t('app', 'Salesforce Id'),
            'salesforceObjectType' => null,
            'salesforceEntityMappings' => null,
            'entity_table' => Yii::t('app', 'Table'),
            'salesforce_object' => Yii::t('app', 'Object Type'),
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria();

        $criteria->compare('t.salesforce_id', $this->salesforce_id, true);
        $criteria->compare('t.status', $this->status, true);
        $criteria->compare('sem.id', $this->salesforce_entity_mapping_id, true);
        $criteria->compare('sem.entity_table', $this->entity_table, true);
        $criteria->compare('sem.entity_id', $this->entity_id, true);
        $criteria->compare('sem.salesforce_entity_id', $this->salesforce_entity_id, true);
        $criteria->compare('sfo.name', $this->salesforce_object, true);
        $criteria->compare('t.salesforce_object_type_id', $this->salesforce_object_type_id);

        $criteria->select ='t.*, sem.id as salesforce_entity_mapping_id, sem.entity_id as entity_id, sem.entity_table as entity_table, sem.salesforce_entity_id as salesforce_entity_id, sfo.id as sfo_id, sfo.name as salesforce_object';
        $criteria->join = '
                        INNER JOIN salesforce_entity_mapping sem
                            ON sem.salesforce_entity_id = t.id
                        INNER JOIN salesforce_object_type sfo
                            ON sfo.id = t.salesforce_object_type_id';

        return new CActiveDataProvider($this, array(
           'criteria' => $criteria, 'pagination' => array('pageSize' => 100)
        ));
    }

}
